Skip to content

Upsert Retriever

Retriever Retrievers.Upsert(RetrieverUpsertParamsparameters, CancellationTokencancellationToken = default)
PUT/api/v1/retrievers

Upsert a new Retriever.

ParametersExpand Collapse
RetrieverUpsertParams parameters
required string name

Body param: A name for the retriever tool. Will default to the pipeline name if not provided.

maxLength3000
minLength1
string? organizationID

Query param

formatuuid
string? projectID

Query param

formatuuid
IReadOnlyList<RetrieverPipeline> pipelines

Body param: The pipelines this retriever uses.

required string? Description

A description of the retriever tool.

maxLength15000
required string? Name

A name for the retriever tool. Will default to the pipeline name if not provided.

maxLength3000
minLength1
required string PipelineID

The ID of the pipeline this tool uses.

formatuuid
PresetRetrievalParams PresetRetrievalParameters

Parameters for retrieval configuration.

Double? Alpha

Alpha value for hybrid retrieval to determine the weights between dense and sparse retrieval. 0 is sparse retrieval and 1 is dense retrieval.

maximum1
minimum0
string ClassName
Double? DenseSimilarityCutoff

Minimum similarity score wrt query for retrieval

maximum1
minimum0
Long? DenseSimilarityTopK

Number of nodes for dense retrieval.

maximum100
minimum1
Boolean? EnableReranking

Enable reranking for retrieval

Long? FilesTopK

Number of files to retrieve (only for retrieval mode files_via_metadata and files_via_content).

maximum5
minimum1
Long? RerankTopN

Number of reranked nodes for returning.

maximum100
minimum1
RetrievalMode RetrievalMode

The retrieval mode for the query.

One of the following:
"auto_routed"AutoRouted
"chunks"Chunks
"files_via_content"FilesViaContent
"files_via_metadata"FilesViaMetadata
DeprecatedBoolean RetrieveImageNodes

Whether to retrieve image nodes.

Boolean RetrievePageFigureNodes

Whether to retrieve page figure nodes.

Boolean RetrievePageScreenshotNodes

Whether to retrieve page screenshot nodes.

MetadataFilters? SearchFilters

Metadata filters for vector stores.

required IReadOnlyList<Filter> Filters
One of the following:
class MetadataFilter:

Comprehensive metadata filter for vector stores to support more operators.

Value uses Strict types, as int, float and str are compatible types and were all converted to string before.

See: https://docs.pydantic.dev/latest/usage/types/#strict-types

required string Key
required Value? Value
One of the following:
Double
string
IReadOnlyList<string>
IReadOnlyList<Double>
IReadOnlyList<Long>
Operator Operator

Vector store filter operator.

One of the following:
"!="
"<"
"<="
"=="
">"
">="
"all"All
"any"Any
"contains"Contains
"in"In
"is_empty"IsEmpty
"nin"Nin
"text_match"TextMatch
"text_match_insensitive"TextMatchInsensitive
MetadataFilters
Condition? Condition

Vector store filter conditions to combine different filters.

One of the following:
"and"And
"not"Not
"or"Or
IReadOnlyDictionary<string, SearchFiltersInferenceSchema?>? SearchFiltersInferenceSchema

JSON Schema that will be used to infer search_filters. Omit or leave as null to skip inference.

One of the following:
IReadOnlyDictionary<string, JsonElement>
IReadOnlyList<JsonElement>
string
Double
Boolean
Long? SparseSimilarityTopK

Number of nodes for sparse retrieval.

maximum100
minimum1
ReturnsExpand Collapse
class Retriever:

An entity that retrieves context nodes from several sub RetrieverTools.

required string ID

Unique identifier

formatuuid
required string Name

A name for the retriever tool. Will default to the pipeline name if not provided.

maxLength3000
minLength1
required string ProjectID

The ID of the project this retriever resides in.

formatuuid
DateTimeOffset? CreatedAt

Creation datetime

formatdate-time
IReadOnlyList<RetrieverPipeline> Pipelines

The pipelines this retriever uses.

required string? Description

A description of the retriever tool.

maxLength15000
required string? Name

A name for the retriever tool. Will default to the pipeline name if not provided.

maxLength3000
minLength1
required string PipelineID

The ID of the pipeline this tool uses.

formatuuid
PresetRetrievalParams PresetRetrievalParameters

Parameters for retrieval configuration.

Double? Alpha

Alpha value for hybrid retrieval to determine the weights between dense and sparse retrieval. 0 is sparse retrieval and 1 is dense retrieval.

maximum1
minimum0
string ClassName
Double? DenseSimilarityCutoff

Minimum similarity score wrt query for retrieval

maximum1
minimum0
Long? DenseSimilarityTopK

Number of nodes for dense retrieval.

maximum100
minimum1
Boolean? EnableReranking

Enable reranking for retrieval

Long? FilesTopK

Number of files to retrieve (only for retrieval mode files_via_metadata and files_via_content).

maximum5
minimum1
Long? RerankTopN

Number of reranked nodes for returning.

maximum100
minimum1
RetrievalMode RetrievalMode

The retrieval mode for the query.

One of the following:
"auto_routed"AutoRouted
"chunks"Chunks
"files_via_content"FilesViaContent
"files_via_metadata"FilesViaMetadata
DeprecatedBoolean RetrieveImageNodes

Whether to retrieve image nodes.

Boolean RetrievePageFigureNodes

Whether to retrieve page figure nodes.

Boolean RetrievePageScreenshotNodes

Whether to retrieve page screenshot nodes.

MetadataFilters? SearchFilters

Metadata filters for vector stores.

required IReadOnlyList<Filter> Filters
One of the following:
class MetadataFilter:

Comprehensive metadata filter for vector stores to support more operators.

Value uses Strict types, as int, float and str are compatible types and were all converted to string before.

See: https://docs.pydantic.dev/latest/usage/types/#strict-types

required string Key
required Value? Value
One of the following:
Double
string
IReadOnlyList<string>
IReadOnlyList<Double>
IReadOnlyList<Long>
Operator Operator

Vector store filter operator.

One of the following:
"!="
"<"
"<="
"=="
">"
">="
"all"All
"any"Any
"contains"Contains
"in"In
"is_empty"IsEmpty
"nin"Nin
"text_match"TextMatch
"text_match_insensitive"TextMatchInsensitive
MetadataFilters
Condition? Condition

Vector store filter conditions to combine different filters.

One of the following:
"and"And
"not"Not
"or"Or
IReadOnlyDictionary<string, SearchFiltersInferenceSchema?>? SearchFiltersInferenceSchema

JSON Schema that will be used to infer search_filters. Omit or leave as null to skip inference.

One of the following:
IReadOnlyDictionary<string, JsonElement>
IReadOnlyList<JsonElement>
string
Double
Boolean
Long? SparseSimilarityTopK

Number of nodes for sparse retrieval.

maximum100
minimum1
DateTimeOffset? UpdatedAt

Update datetime

formatdate-time

Upsert Retriever

RetrieverUpsertParams parameters = new() { Name = "x" };

var retriever = await client.Retrievers.Upsert(parameters);

Console.WriteLine(retriever);
{
  "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "name": "x",
  "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "created_at": "2019-12-27T18:11:19.117Z",
  "pipelines": [
    {
      "description": "description",
      "name": "x",
      "pipeline_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "preset_retrieval_parameters": {
        "alpha": 0,
        "class_name": "class_name",
        "dense_similarity_cutoff": 0,
        "dense_similarity_top_k": 1,
        "enable_reranking": true,
        "files_top_k": 1,
        "rerank_top_n": 1,
        "retrieval_mode": "auto_routed",
        "retrieve_image_nodes": true,
        "retrieve_page_figure_nodes": true,
        "retrieve_page_screenshot_nodes": true,
        "search_filters": {
          "filters": [
            {
              "key": "key",
              "value": 0,
              "operator": "!="
            }
          ],
          "condition": "and"
        },
        "search_filters_inference_schema": {
          "foo": {
            "foo": "bar"
          }
        },
        "sparse_similarity_top_k": 1
      }
    }
  ],
  "updated_at": "2019-12-27T18:11:19.117Z"
}
Returns Examples
{
  "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "name": "x",
  "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "created_at": "2019-12-27T18:11:19.117Z",
  "pipelines": [
    {
      "description": "description",
      "name": "x",
      "pipeline_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "preset_retrieval_parameters": {
        "alpha": 0,
        "class_name": "class_name",
        "dense_similarity_cutoff": 0,
        "dense_similarity_top_k": 1,
        "enable_reranking": true,
        "files_top_k": 1,
        "rerank_top_n": 1,
        "retrieval_mode": "auto_routed",
        "retrieve_image_nodes": true,
        "retrieve_page_figure_nodes": true,
        "retrieve_page_screenshot_nodes": true,
        "search_filters": {
          "filters": [
            {
              "key": "key",
              "value": 0,
              "operator": "!="
            }
          ],
          "condition": "and"
        },
        "search_filters_inference_schema": {
          "foo": {
            "foo": "bar"
          }
        },
        "sparse_similarity_top_k": 1
      }
    }
  ],
  "updated_at": "2019-12-27T18:11:19.117Z"
}
Note for AI agents: this documentation is built for programmatic access. - Overview of all docs: https://developers.llamaindex.ai/llms.txt - Any page is available as raw Markdown by appending index.md to its URL — e.g. https://developers.llamaindex.ai/llamaparse/parse/getting_started/index.md - Agent-friendly REST search APIs live under https://developers.llamaindex.ai/api/ — search (BM25 full-text), grep (regex), read (fetch a page), and list (browse the doc tree). See https://developers.llamaindex.ai/llms.txt for parameters. - A hosted documentation MCP server is available at https://developers.llamaindex.ai/mcp. If you support MCP, you can ask the user to install it for browsing these docs directly (an alternative to the REST API). Setup: https://developers.llamaindex.ai/for-agents/mcp/ - Other LlamaIndex tooling for agents — the LlamaParse Platform MCP server, agent skills and plugins, and the n8n node — is mapped at https://developers.llamaindex.ai/for-agents/